#include "lanhep.h"
	
		
void alg2_add_ml(Term a1, List ml)
	{
	
	List ml1, l1,l2;
	
	ml1=ConsumeCompoundArg(a1,5);
	
	for(l1=ml;l1;l1=ListTail(l1))
	{
		Term m2;
		m2=ListFirst(l1);
		
		for(l2=ml1;l2;l2=ListTail(l2))
		{
		Term t;
		t=ListFirst(l2);
		if(EqualTerms(CompoundArg2(t),CompoundArg2(m2)) &&
			EqualTerms(CompoundArgN(t,3),CompoundArgN(m2,3)))
				{
				int d1,n1,d2,n2,d,n,gc;
				n1=IntegerValue(CompoundArg1(CompoundArg1(t)));
				d1=IntegerValue(CompoundArg2(CompoundArg1(t)));
				n2=IntegerValue(CompoundArg1(CompoundArg1(m2)));
				d2=IntegerValue(CompoundArg2(CompoundArg1(m2)));
				d=d1*d2;
				n=n1*d2+n2*d1;
				if(n==0)
					{
					ml1=CutFromList(ml1,l2);
					}
				else
					{
					gc=gcf(n,d);
					d/=gc;
					n/=gc;
					SetCompoundArg(CompoundArg1(t),1,NewInteger(n));
					SetCompoundArg(CompoundArg1(t),2,NewInteger(d));
					}
				FreeAtomic(m2);
				break;
				}
		}
		
		if(is_empty_list(l2))
			ml1=AppendLast(ml1,m2);
	}
	
	RemoveList(ml);
	SetCompoundArg(a1,5,ml1);
}
			


static void alg2_add_11(Term a1, Term a2)
	{
	Term m2;
	List ml,l;
	m2=ConsumeCompoundArg(a2,5);
	FreeAtomic(a2);
	a2=ListFirst(m2);
	RemoveList(m2);
	m2=a2;
	ml=ConsumeCompoundArg(a1,5);
	l=ml;
	while(!is_empty_list(l))
		{
		Term t;
		t=ListFirst(l);
		if(EqualTerms(CompoundArg2(t),CompoundArg2(m2)) &&
			EqualTerms(CompoundArgN(t,3),CompoundArgN(m2,3)))
				{
				int d1,n1,d2,n2,d,n,gc;
				n1=IntegerValue(CompoundArg1(CompoundArg1(t)));
				d1=IntegerValue(CompoundArg2(CompoundArg1(t)));
				n2=IntegerValue(CompoundArg1(CompoundArg1(m2)));
				d2=IntegerValue(CompoundArg2(CompoundArg1(m2)));
				d=d1*d2;
				n=n1*d2+n2*d1;
				if(n==0)
					{
					ml=CutFromList(ml,l);
					}
				else
					{
					gc=gcf(n,d);
					d/=gc;
					n/=gc;
					SetCompoundArg(CompoundArg1(t),1,NewInteger(n));
					SetCompoundArg(CompoundArg1(t),2,NewInteger(d));
					}
				FreeAtomic(m2);
				SetCompoundArg(a1,5,ml);
				return ;
				}
		l=ListTail(l);
		}
		
	ml=AppendLast(ml,m2);
	SetCompoundArg(a1,5,ml);
	}
			
	

static List alg2_add_1(List l, Term a2)
	{
	List l1;
	Term pl;
	pl=CompoundArg1(a2);
	l1=l;
	while(!is_empty_list(l1))
		{
		Term t1;
		t1=ListFirst(l1);
		if(EqualTerms(CompoundArg1(t1),pl))
			{
			alg2_add_11(t1,a2);
			return l;
			}
		l1=ListTail(l1);
		}
	return AppendLast(l,a2);
	}


List alg2_add(List a1, List a2)
	{
	List a2s;
	int alen, acur;
	char buf[40];
	alen=ListLength(a2);
	acur=0;
	a2s=a2;
	while(!is_empty_list(a2))
		{
		acur++;
		sprintf(buf,"alg2_add: %d of %d",acur,alen);
		RegisterLine(buf);
		a1=alg2_add_1(a1,ListFirst(a2));
		a2=ListTail(a2);
		UnregisterLine();
		}
	RemoveList(a2s);
	return a1;	
	}	
	

static int h_value(List prt)
{
	List l;
	int ret=43;
	for(l=prt;l;l=ListTail(l))
	{
		char *p;
		int nn;
		p=AtomValue(CompoundArg1(ListFirst(l)));
		nn=p[0]*13+p[1]*107+p[2]*511;
		ret+=ret*nn;
	}
	return ret;
}
	
void alg2_hash_add(List *lagr, int hsz, List a2)
	{
	List a2s;
	int alen, acur;
	char buf[40];
		
	alen=ListLength(a2);
	acur=0;
	a2s=a2;
	while(!is_empty_list(a2))
		{
		int hv;
		acur++;
		sprintf(buf,"alg2_add: %d of %d",acur,alen);
		RegisterLine(buf);
		hv=h_value(CompoundArg1(ListFirst(a2)));
		hv%=hsz;
		if(hv<0)
			hv=-hv;
		
		lagr[hv]=alg2_add_1(lagr[hv],ListFirst(a2));
		a2=ListTail(a2);
		UnregisterLine();
		}
	RemoveList(a2s);
	return;
	}	
	
